Issue 56023 - External program "DLINKABP.EXE" does not work for OOo 2.0 writer
Summary: External program "DLINKABP.EXE" does not work for OOo 2.0 writer
Status: CONFIRMED
Alias: None
Product: Writer
Classification: Application
Component: editing (show other issues)
Version: OOo 2.0
Hardware: Other Windows XP
: P4 Trivial with 1 vote (vote)
Target Milestone: ---
Assignee: AOO issues mailing list
QA Contact:
URL:
Keywords: oooqa
Depends on:
Blocks:
 
Reported: 2005-10-14 17:48 UTC by rainbowclown
Modified: 2013-08-07 14:38 UTC (History)
3 users (show)

See Also:
Issue Type: DEFECT
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments
Correctly linked text in 1.1.5 (42.98 KB, application/pdf)
2005-10-14 17:50 UTC, rainbowclown
no flags Details
incorrect result in 2.0 (45.69 KB, application/pdf)
2005-10-14 17:51 UTC, rainbowclown
no flags Details
How to find out Ooo version (44.13 KB, application/vnd.oasis.opendocument.text)
2005-10-15 07:52 UTC, Rainer Bielefeld
no flags Details
document showing somes teps from "does not work" to "works" (9.45 KB, application/vnd.oasis.opendocument.text)
2005-10-17 20:02 UTC, Rainer Bielefeld
no flags Details
PDF showing results on my PC (64.03 KB, application/pdf)
2005-10-17 20:03 UTC, Rainer Bielefeld
no flags Details
rtf that did not work, and some that did (69.60 KB, application/pdf)
2005-10-18 03:16 UTC, rainbowclown
no flags Details
clipboard content for further tests (13.29 KB, application/x-compressed)
2005-10-18 07:02 UTC, Rainer Bielefeld
no flags Details

Note You need to log in before you can comment on or make changes to this issue.
Description rainbowclown 2005-10-14 17:48:30 UTC
Windows XP Service Pack 1

We sell fonts and LinkLetter applications that "convert" fonts from unlinked
cursive to linked cursive.  The process:
1. In a word processor, select our font and type the text.
2. Copy or cut the text to the clipboard.
3. Run LinkLetter.
4. Paste the linked text back into the document.

The fonts use character positions between 128 and 255 for "stripped" letters and
the connections between the stripped letters.  LinkLetter scans all the text
looking for our font, strips each letter, puts in the connections between each
letter, and puts the result back on the clipboard. 

A user reported that our linked cursive does not work in 2.0.

I downloaded 2.0 and 1.1.5 yesterday.  

Open Office 1.1.5 Text Document works fine.  When I type the same text in Office
2.0 Writer, run Linkletter, and paste the text back in, I get boxes, which
typically means that the characters are undefined.

If I type the text in 1.1.5, run Linkletter, and paste into 2.0, the text is
properly linked.  But if I select the text that I just pasted into 2.0 and run
Linkletter again, I get the boxes.

I have created PDFs that show the rtf before and after running Linkletter for
both 1.1.5 and 2.0.  

I'm new to OpenOffice, and can't figure out how to attach the PDFs.  Please tell
me how/where to send them.

Thanks.

Jan
1-800-806-2155
Comment 1 rainbowclown 2005-10-14 17:50:28 UTC
Created attachment 30447 [details]
Correctly linked text in 1.1.5
Comment 2 rainbowclown 2005-10-14 17:51:35 UTC
Created attachment 30448 [details]
incorrect result in 2.0
Comment 3 Rainer Bielefeld 2005-10-14 18:09:59 UTC
@ rainbowclown
Pls understand that we need much more information for handling this problem:

What's the exact name / version of the  software you used for that test?

Where can we get a test version of the font and the software (you can mail a
link per "Private Mail" to some QA staff, if yo do not want to "publish" it here.

Does that problem really only appear in WRITER or also in other OOo modules (or
can it only appear in WRITER because that software only works together with WRITER)

Pls. contribute a more meaningful subject like "MyFineSoftware.exe" does no
longer work with OOo 2.0

Pls. contribute the exact OOo version you used for your test - I did not hear
that 2.0 final is available :-/
Comment 4 rainbowclown 2005-10-14 22:48:33 UTC
I'll attempt to answer rainerbielefeld's questions.

>   What's the exact name / version of the software you used for that test?
Are you talking about our software, or OpenOffice?  If our software, the font is
AB Cursive (our font) and the program is LinkLetter AB, available only from our
company Educational Fontware, Inc.  We have several hundred cursive fonts, with
corresponding LinkLetter programs.  The same kind of problem occurs for every
font that I have tried.

If you are asking about Open Office, I can't find version information when I
click Help About.  All I see is "OpenOffice.org 2.0"  Where would I find version
iformation?

> Where can we get a test version of the font and the software?
I will be happy to email someone the font and the Linkletter program I used for
the test.  The debug version (which outputs the rft) or just the regular code? 
I do not want to make the font and program available to anyone, so tell me how I
get them to just you, please.

> Does that problem really only appear in WRITER ...
Our Linkletter works on either TEXT or RTF on the clipboard.  I tried the OO 2.0
spreadsheet with the same font and text, and it worked fine.  

> Pls. contribute the exact OOo version you used for your test 
If you are asking about Open Office, I can't find version information when I
click Help About.  All I see is "OpenOffice.org 2.0"  I downloaded whatever was
on the website yesterday.
Comment 5 Rainer Bielefeld 2005-10-15 07:50:20 UTC
@ rainbowclown,

you can send one font and and a normal "user version" of the program to my email
address (click 'rainerbielefeld' in comment header), so that I can do all steps
 reported by you and also some further tests. May be it will be necessary to
forward that "test kit" to a developer, I will inform you before.

The exact version of your OOo you can find in Menu "Help - About Openoffice.org"
(pls see attached "version.png").
Comment 6 Rainer Bielefeld 2005-10-15 07:52:00 UTC
Created attachment 30475 [details]
How to find out Ooo version
Comment 7 jolatt 2005-10-16 10:23:56 UTC
Hi rainerbielefeld,
your way how to find out the OOo-version isn't right. There will only be shown 
Openoffice.org 2.0.

In menu "Help - About Openoffice.org" you have to type SDT while you hold down 
the STRG (CTRL) button.
Comment 8 rainbowclown 2005-10-16 19:19:55 UTC
The Help About method shows 
680M2 Build 8964
Comment 9 michael.ruess 2005-10-17 10:43:22 UTC
Reassigned to US.
Comment 10 Rainer Bielefeld 2005-10-17 20:01:03 UTC
I did some tests and can confirm that there are problems, but to figure out the
reasons for the problem will still cause some further tests. My first results
are: If I create a new document with some words with special font in it
"DLINKABP.EXE" will not have the expected result, I do not have "boxes" instead
of letters, but somehow "chinese" characters.  The problem seems to be caused by
the content copied from OOo 2.0 to the clipboard, that does not work for 
"DLINKABP.EXE"; all pasted content from other applications (OOo 1.1.4) works
fine for  "DLINKABP.EXE"; pasted content from there looks fine in an  OOo 2.0
document after work of "DLINKABP.EXE".

Funny thing: If I save and reopen document with pasted content from 1.1.4, I can
use  "DLINKABP.EXE" without problems for the first paragraph containing font "ab
cursive", which did not work before I pasted content from 1.1.4.

I will do some further tests, for first I will attach a .odt with some test
results and also a PDF from that document; may be a developer can see what's
going wrong there.
Comment 11 Rainer Bielefeld 2005-10-17 20:02:11 UTC
Created attachment 30566 [details]
document showing somes teps from "does not work" to  "works"
Comment 12 Rainer Bielefeld 2005-10-17 20:03:30 UTC
Created attachment 30567 [details]
PDF showing results on my PC
Comment 13 Rainer Bielefeld 2005-10-17 20:20:47 UTC
@rainbowclown:
can you confirm that in firstdidnotwork.odt you can now copy paste the first
paragraph with expected "DLINKABP.EXE" result?
Can you confirm my results as follwoing?

I had to learn that it is more simple:

1. I create a new document with some text containing "ab cursive"
2. save
3.  higlight (mark) complete text containing words in "ab cursive" and copy 
    to clipboard
4. run  "DLINKABP.EXE"
5. Paste
   result: funny characters, did not work.
6. close document with saveing content

11. repoen
12. higlight (mark) complete text containing words in "ab cursive"
13. copy to clipboard
14. run  "DLINKABP.EXE"
15. Paste
     result: as expected, characters in words with "ab cursive" are connected 


  
Comment 14 Rainer Bielefeld 2005-10-17 20:21:45 UTC
Thosem problems with "funny characters" really only appear in WRITER, not in
CALC and even not in DRAW.
Comment 15 rainbowclown 2005-10-18 03:07:34 UTC
I have confirmed your results; saving the document, and running Linkletter after
reopening does produce correctly linked tests.  In fact, if I saved the text I
had typed in the cursive font, reopened the document, and then linked the text,
it worked properly.

I experimented, and dumped the rtf as follows:
1.  into linkletter without saving the document
2.  incorrect results out of the first linkletter
3.  saved the document, reopened, and dumped rtf before linkletter
4.  dumped rtf after the successful link.

There are some differences in the rtf in dump 1 and 3.  The one difference that
makes me suspicious is that fcharset128 is associated with the AB Cursive font
in the fonttbl in dump 1.  However, in dump 3, it is fcharset0.

Just to make us all crazy, it is fcharset1 in the spreadsheet app, which works
correctly.

I will do the pdf that I made of my test as an attachment.
Comment 16 rainbowclown 2005-10-18 03:16:44 UTC
Created attachment 30586 [details]
rtf that did not work, and some that did
Comment 17 Rainer Bielefeld 2005-10-18 06:59:31 UTC
Some last tests (all with 2.0 (1.9.m125) German version WIN XP:
[680m125(Build8947)]):

1. I Created new writer document with text content "This is some text This is 
   some ab cursive text This is some text"
2. Marked text area "This is some ab cursive text" and changed font to 
  'ab cursive'
3. saved document.
4. Marked complete text and copied to clipboard ('clipboard0.CLP')
5. ran DLINKABP.EXE ('clipboard0afterdlinkabp.CLP')
6. Pasted without expected success as per bug report
7. saved and closed file

11. reopened document 
14. Marked complete text and copied to clipboard ('clipboard1.CLP')
5. ran DLINKABP.EXE ('clipboard1afterdlinkabp.CLP')
6. Pasted successful with linked text in 'ab cursive'

If you load 'clipboard0.CLP' to clipboard using win program 'clipbrd.exe',
DLINKABP.EXE will always fail to produce linked characters from that clipboard
content.

If you load 'clipboard1.CLP' to clipboard using win program 'clipbrd.exe',
DLINKABP.EXE will always prduce linked characters successfully. 

The problems seem to be caused from the differences between those clipboard
contents I attached in clipboards.zip
  
Comment 18 Rainer Bielefeld 2005-10-18 07:02:03 UTC
Created attachment 30588 [details]
clipboard content for further tests
Comment 19 ulf.stroehler 2005-10-18 19:24:40 UTC
@flr: are you willing to handle this one, or do you need further investigations
from QA people?

@submitter: can you pls. try to describe technically what your program does (why
clipboard, why RTF, how are the so called links generated, how about UNICODE
characters, how are these specific fonts encoded, etc.?)
Comment 20 rainbowclown 2005-10-19 15:48:34 UTC
A summary of our Linkletter program:

1. In a word processor, select our font and type the text.
2. Copy or cut the text to the clipboard.
3. Run LinkLetter.
4. Paste the linked text back into the document.

The fonts use character positions between 128 and 255 for "stripped" letters and
the connections between the stripped letters.  LinkLetter scans all the text
looking for our font, strips each letter, puts in the connections between each
letter, and puts the result back on the clipboard.

In more detail:
1.  Linkletter does a "pre-scan" of the rtf, looking for the \fonttbl "key". 
Within the fonttbl key, it makes sure that AB CUrsive is used in the document. 
If not, it's done.
2.  Now it scans through the rtf, looking at each control character until it
finds a \fnnn, where nnn is the font number of one of the AB Cursive fonts found
in the \fonttbl.  
3.  It then extracts each character in \fnnn sequence, and calls the link
subroutine.
4.  The link subroutine has a table for each "normal" character in the font,
where normal are the ones that are typed on the keyboard.  Each character has a
corresponding "stripped" character, which is the shape of the letter without any
of the beginning or ending strokes.  These stripped letters are in character
positions 128 through 255 in the font.  Also in 128 through 255 are the
connections between the letters.  And the link routine can relink text because
it recognizes the stripped characters.
5.  The link routine strips the character to its basic shape, and looks at the
character preceeding this one in the output rtf.  It determines which connector
to use to properly join the two letters.  Sometimes, this invloves replacing a
preceeding character in the output rtf.
6.  The main routine repeats this same processing for each AB Cursive character
it finds.

Do a test with text like "above and about" using AB Cursive, using the
save/reopen method that results in correctly linked text.

Change all of the linked text to another font, such as Times New Roman. Looks
like Greek, right?  What you are seeing are the stripped letters and the
connections between them.

Regarding unicode, we look for the syntax \unnnn.  We developed a table that
shows the corresponding character in the 128-255 range, drop the unicode and the
hex equivalent if that is in the input rtf, and substitute the 128-255 character.  

So far, we've only seen unicode in Microsoft Word 2004 on the Mac and OO.  And
we've only seen it when you link the text a second time.

Comment 21 ulf.stroehler 2005-10-21 17:09:08 UTC
flr?
Comment 22 rainbowclown 2005-11-28 20:10:54 UTC
I just got a call from another user who is having this problem in Open Office 2.0.  

Any idea as to whether it will be fixed or not, and the timeframe?
Comment 23 trinityoaks 2006-11-13 02:20:24 UTC
I am a user of the Linkletter software sold by rainbowclown's company.  I have
had the same difficulty with the software not pasting the correct characters
when used with Open Office 2.0.  (I am currently using OOo v.2.0.3 under Windows
2000 SP4.)  The software DOES work correctly when used with Microsoft Word,
which I'd like to be able to get away from.  I've not tried it with versions of
OOo before 2.0, and for other reasons, I'd rather not have to revert to those.

What can we do (besides "voting" for the issue) to get the ball rolling on a fix
for this?
Comment 24 Rob Weir 2013-07-30 02:43:12 UTC
Reset assignee on issues not touched by assignee in more than 1000 days.